import { defaultRegionInfoProvider } from "./endpoints";
import { Logger as __Logger } from "@aws-sdk/types";
import { parseUrl } from "@aws-sdk/url-parser";
import { ChimeClientConfig } from "./ChimeClient";

/**
 * @internal
 */
export const getRuntimeConfig = (config: ChimeClientConfig = {}) => ({
  apiVersion: "2018-05-01",
  disableHostPrefix: config.disableHostPrefix ?? false,
  logger: config.logger ?? ({} as __Logger),
  regionInfoProvider: config.regionInfoProvider ?? defaultRegionInfoProvider,
  serviceId: config.serviceId ?? "Chime",
  urlParser: config.urlParser ?? parseUrl,
});
