import { defaultRegionInfoProvider } from "./endpoints";
import { Logger as __Logger } from "@aws-sdk/types";
import { parseUrl } from "@aws-sdk/url-parser";
import { ElasticBeanstalkClientConfig } from "./ElasticBeanstalkClient";

/**
 * @internal
 */
export const getRuntimeConfig = (config: ElasticBeanstalkClientConfig = {}) => ({
  apiVersion: "2010-12-01",
  disableHostPrefix: config.disableHostPrefix ?? false,
  logger: config.logger ?? ({} as __Logger),
  regionInfoProvider: config.regionInfoProvider ?? defaultRegionInfoProvider,
  serviceId: config.serviceId ?? "Elastic Beanstalk",
  urlParser: config.urlParser ?? parseUrl,
});
