import { defaultRegionInfoProvider } from "./endpoints";
import { Logger as __Logger } from "@aws-sdk/types";
import { parseUrl } from "@aws-sdk/url-parser";
import { RDSClientConfig } from "./RDSClient";

/**
 * @internal
 */
export const getRuntimeConfig = (config: RDSClientConfig = {}) => ({
  apiVersion: "2014-10-31",
  disableHostPrefix: config.disableHostPrefix ?? false,
  logger: config.logger ?? ({} as __Logger),
  regionInfoProvider: config.regionInfoProvider ?? defaultRegionInfoProvider,
  serviceId: config.serviceId ?? "RDS",
  urlParser: config.urlParser ?? parseUrl,
});
